-- name: [CS] Green Sans
-- description: He's Everybody's Favorite!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local GSANS = "Green Sans"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..GSANS.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_GSANS = smlua_model_util_get_id('green_sans_geo')

local TEX_GSANS = get_texture_info('green_sans_icon')

VOICETABLE_GSANS = {
   	[CHAR_SOUND_LETS_A_GO] = 'CHAR_SOUND_LETS_A_GO.ogg',
	[CHAR_SOUND_PUNCH_YAH] = 'CHAR_SOUND_PUNCH_YAH.ogg',
	[CHAR_SOUND_PUNCH_WAH] = 'CHAR_SOUND_PUNCH_WAH.ogg',
	[CHAR_SOUND_PUNCH_HOO] = 'CHAR_SOUND_PUNCH_HOO.ogg',
	[CHAR_SOUND_YAH_WAH_HOO] = {'CHAR_SOUND_YAH.ogg', 'CHAR_SOUND_WAH.ogg', 'CHAR_SOUND_HOO.ogg'},
	[CHAR_SOUND_HOOHOO] = 'CHAR_SOUND_HOOHOO.ogg',
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'CHAR_SOUND_YAHOO.ogg', 'CHAR_SOUND_WAHA.ogg', 'CHAR_SOUND_YIPPEE.ogg'},
	[CHAR_SOUND_UH] = 'CHAR_SOUND_UH.ogg',
	[CHAR_SOUND_UH2] = 'CHAR_SOUND_UH2.ogg',
	[CHAR_SOUND_UH2_2] = 'CHAR_SOUND_UH2_2.ogg',
	[CHAR_SOUND_OOOF] = 'CHAR_SOUND_OOOF.ogg',
	[CHAR_SOUND_OOOF2] = 'CHAR_SOUND_OOOF2.ogg',
	[CHAR_SOUND_HAHA] = 'CHAR_SOUND_HAHA.ogg',
	[CHAR_SOUND_YAHOO] = 'CHAR_SOUND_YAHOO.ogg',
	[CHAR_SOUND_DOH] = 'CHAR_SOUND_DOH.ogg',
	[CHAR_SOUND_WHOA] = 'CHAR_SOUND_WHOA.ogg',
	[CHAR_SOUND_EEUH] = 'CHAR_SOUND_EEUH.ogg',
	[CHAR_SOUND_WAAAOOOW] = 'CHAR_SOUND_WAAAOOOW.ogg',
	[CHAR_SOUND_TWIRL_BOUNCE] = 'CHAR_SOUND_TWIRL_BOUNCE.ogg',
	[CHAR_SOUND_GROUND_POUND_WAH] = 'CHAR_SOUND_GROUND_POUND_WAH.ogg', 
	[CHAR_SOUND_HRMM] = 'CHAR_SOUND_HRMM.ogg',
	[CHAR_SOUND_HERE_WE_GO] = 'CHAR_SOUND_HERE_WE_GO.ogg',
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'CHAR_SOUND_SO_LONGA_BOWSER.ogg',
	[CHAR_SOUND_ATTACKED] = 'CHAR_SOUND_ATTACKED.ogg',
	[CHAR_SOUND_PANTING] = 'CHAR_SOUND_PANTING.ogg',
	[CHAR_SOUND_ON_FIRE] = 'CHAR_SOUND_ON_FIRE.ogg',
	[CHAR_SOUND_IMA_TIRED] = 'CHAR_SOUND_IMA_TIRED.ogg',
	[CHAR_SOUND_YAWNING] = 'CHAR_SOUND_YAWNING.ogg',
	[CHAR_SOUND_SNORING1] = 'CHAR_SOUND_SNORING1.ogg',
	[CHAR_SOUND_SNORING2] = 'CHAR_SOUND_SNORING2.ogg',
	[CHAR_SOUND_SNORING3] = 'CHAR_SOUND_SNORING3.ogg',
	[CHAR_SOUND_COUGHING1] = 'CHAR_SOUND_COUGHING1.ogg',
	[CHAR_SOUND_COUGHING2] = 'CHAR_SOUND_COUGHING2.ogg',
	[CHAR_SOUND_COUGHING3] = 'CHAR_SOUND_COUGHING3.ogg',
	[CHAR_SOUND_DYING] = 'CHAR_SOUND_DYING.ogg',
	[CHAR_SOUND_DROWNING] = 'CHAR_SOUND_DROWNING.ogg',
	[CHAR_SOUND_MAMA_MIA] = 'CHAR_SOUND_MAMA_MIA.ogg'
}

local PALETTE_GSANS =  {
    [PANTS]  = { r = 0x00, g = 0xff, b = 0x00 },
    [SHIRT]  = { r = 0x00, g = 0xff, b = 0x00 },
    [GLOVES] = { r = 0x00, g = 0xff, b = 0x00 },
    [SHOES]  = { r = 0x00, g = 0xff, b = 0x00 },
    [HAIR]   = { r = 0x00, g = 0xff, b = 0x00 },
    [SKIN]   = { r = 0x00, g = 0xff, b = 0x00 },
    [CAP]    = { r = 0x00, g = 0xff, b = 0x00 },
    [EMBLEM] = { r = 0x00, g = 0xff, b = 0x00 },
}

local capGSANS = {
    normal = smlua_model_util_get_id("gsans_head_geo"),
    wing = smlua_model_util_get_id("gsans_wing_head_geo"),
    metal = smlua_model_util_get_id("gsans_metal_head_geo"),
    metalWing = smlua_model_util_get_id("gsans_metal_wing_head_geo")
}

local HEALTH_METER_GSANS = {
    label = {
        left = get_texture_info("gsans-left"),
        right = get_texture_info("gsans-right"),
    },
    pie = {
        [1] = get_texture_info("hp-1"),
        [2] = get_texture_info("hp-2"),
        [3] = get_texture_info("hp-3"),
        [4] = get_texture_info("hp-4"),
        [5] = get_texture_info("hp-5"),
        [6] = get_texture_info("hp-6"),
        [7] = get_texture_info("hp-7"),
        [8] = get_texture_info("hp-8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_GSANS = _G.charSelect.character_add("Green Sans", {"Ported to Coop-DX by Jer", "Voice Acting by Georgelolwut", "Model by Coolbic", "Health Meter by blazingphantasm", "Green Sans by goinks"}, "Awesome Games", {r = 000, g = 255, b = 000}, E_MODEL_GSANS, CT_MARIO, TEX_GSANS)
    _G.charSelect.character_add_voice(E_MODEL_GSANS, VOICETABLE_GSANS)
    _G.charSelect.character_add_palette_preset(E_MODEL_GSANS, PALETTE_GSANS)
    _G.charSelect.character_add_caps(E_MODEL_GSANS, capGSANS)
    _G.charSelect.character_add_health_meter(CT_GSANS, HEALTH_METER_GSANS)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GSANS then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GSANS then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)